use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_dir_path

include 'macros.inc'
include 'vectors.inc' ;vectors functions constant
include 'load_lib.mac'

@use_library

arr0c:
  .x dd 0.0
  .y dd 0.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale
arr0v:
  dw 4
  dd 0.0,0.0, -7.0,-3.0, -7.0,3.0, 0.0,0.0
  dw 0
arr1v:
  dw 5
  dd 8.0,0.0, -2.0,-3.0, 0.0,0.0, -2.0,3.0, 8.0,0.0
  dw 0

align 4
start:
  mov ecx,sc
  mov edx,sizeof.system_colors
  mcall 48,3
  mcall 40,0x25

  sys_load_library vectors_name, cur_dir_path, library_path, system_path, \
    err_message_found_lib, head_f_l, vectors_lib_import, err_message_import, head_f_i

;  push dword arr0v
;  call [vect_conv_cont]
;  push dword arr1v
;  call [vect_conv_cont]

red_win:
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0xffffff;[sc.work]
  or  edx,0x33000000
  mov edi,hed
  mcall


  mov edx,0xff
  mov eax,30*65536+70
  mov ebx,200*65536+170
  call draw_arrow

  mov edx,0xff00
  mov eax,180*65536+10
  mov ebx,130*65536+110
  call draw_arrow

  mov edx,0xff0000
  mov eax,230*65536+180
  mov ebx,100*65536+180
  call draw_arrow

  push dword 0x808000
  push dword 230*65536+150
  push dword 100*65536+150
  push dword 180*65536+30
  call [vect_c_bezier]

  mcall 12,2

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x3
  jz button
  jmp still

;input:
; eax = x0,y0
; ebx = x1,y1
; edx = color
draw_arrow:
  push ecx
    mov ecx,ebx
    sub cx,ax
    ror ecx,16
    ror eax,16
    sub cx,ax
    ;ror ecx,16
    ror eax,16
    push dword ecx
    call [vect_opred2i]
    finit
    mov ecx,dword [vect_o_ang]
    fld dword [ecx]
    fstp dword [arr0c.a]
  pop ecx
;---------------------------------------------
  push eax ebx ;  
    mov dword[o_dan],eax

    fild word [o_dan]
    fstp dword [arr0c.y]
    fild word [o_dan+2]
    fstp dword [arr0c.x]

    push dword edx
    push dword arr1v
    push dword arr0c
    call [vect_draw_cont]
  pop ebx eax
;---------------------------------------------
  push edx eax ebx
  call [vect_line]
;---------------------------------------------
  push eax ebx ; 
    mov dword[o_dan],ebx

    fild word [o_dan]
    fstp dword [arr0c.y]
    fild word [o_dan+2]
    fstp dword [arr0c.x]

    push dword edx
    push dword arr0v
    push dword arr0c
    call [vect_draw_cont]
  pop ebx eax
;---------------------------------------------
  ret


button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  


o_dan dd ?
hed db 'Drawing arrows',0
sc system_colors 

;--------------------------------------------------
align 4
vectors_lib_import:
  vect_line dd av_line
  vect_c_bezier dd av_c_bezier
  vect_conv_cont dd av_conv_cont
  vect_draw_cont dd av_draw_cont
  vect_opred2i dd av_opred2i
  vect_line_len4i dd av_line_len4i
  vect_o_len dd av_o_len
  vect_o_ang dd av_o_ang

  dd 0,0
  av_line db 'vect_line',0
  av_c_bezier db 'vect_c_bezier',0
  av_conv_cont db 'vect_conv_cont',0
  av_draw_cont db 'vect_draw_cont',0
  av_opred2i db 'vect_opred2i',0
  av_line_len4i db 'vect_line_len4i',0
  av_o_len db 'vect_o_len',0
  av_o_ang db 'vect_o_ang',0

;--------------------------------------------------
system_path db '/sys/lib/'
vectors_name db 'vectors.obj',0
err_message_found_lib db 'Sorry I cannot load library vectors.obj',0
head_f_i:
head_f_l db 'System error',0
err_message_import db 'Error on load import library vectors.obj',0
;--------------------------------------------------

i_end: ; 
  rb 1024
stacktop:
  cur_dir_path:
    rb 4096
  library_path:
    rb 4096
mem:

