use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_dir_path

include 'macros.inc'
include 'vectors.inc' ;vectors functions constant
include 'load_lib.mac'

@use_library

pi_6 equ 0.52359877559829887307710723054658
pi_3 equ 1.0471975511965977461542144610932
pi_30 equ 0.10471975511965977461542144610932

cen_pt:
  dd 150.0,110.0,0.0,1.0
  dd 150.0,110.0,pi_6,1.0
  dd 150.0,110.0,pi_3,1.0

cif_tbl:
  dw 8+VECT_PARAM_PROP_L
  dd 0x0002
  dd 0.0,80.0, 0.0,100.0, 80.0,0.0, 100.0,0.0
  dd 0.0,-80.0, 0.0,-100.0, -80.0,0.0, -100.0,0.0
  dw 0

c_pt_arr:
  dd 150.0,110.0
  .h:
  dd 0.0,1.0
  dd 150.0,110.0
  .m:
  dd 0.0,1.0
  dd 150.0,110.0
  .s:
  dd 0.0,1.0

arr_h:
  dw 5
  dd 5.0,0.0, 0.0,-50.0, -5.0,0.0, 0.0,10.0, 5.0,0.0
  dw 0
arr_m:
  dw 5
  dd 0.0,3.0, 3.0,0.0, 0.0,-60.0, -3.0,0.0, 0.0,3.0
  dw 0
arr_s:
  dw 2
  dd 0.0,5.0, 0.0,-70.0
  dw 0

erase_h db 0x25 ;first erase
erase_m db 0x61 ;first erase
o_dan dw ?
const_pi_6 dd pi_6
const_pi_30 dd pi_30
last_time dd ?


align 4
start:
  mcall 40,0x27

  sys_load_library vectors_name, cur_dir_path, library_path, system_path, \
    err_message_found_lib, head_f_l, vectors_lib_import, err_message_import, head_f_i

   mcall   26, 9
   mov	 [last_time], ebx

red_win:
  call draw_window

still:
   mcall 26, 9
   mov ebx, [last_time]
   add ebx, 100 ;delay
   sub ebx, eax
   cmp ebx, 100 ;delay
   ja it_is_time_now
   test   ebx, ebx
   jz it_is_time_now
   mcall 23

  cmp eax,0
  je it_is_time_now

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x2
  jz key
  cmp al,0x3
  jz button
  jmp still

draw_window:
  push eax ebx ecx edx edi
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0+0x33000000
  mov edi,hed
  mcall

  mov eax,4 ; 
  mov ebx,5*65536+5
  mov ecx,0xffff00
  or  ecx,0x80000000
  mov edx,txtInfo
  mcall

  call draw_objects

  mcall 12,2
  pop edi edx ecx ebx eax
  ret

draw_objects:

  push dword 0xff0000
  push dword arr_h
  push dword c_pt_arr
  call [vect_draw_cont]

  mov eax,c_pt_arr
  add eax,16
  push dword 0xff
  push dword arr_m
  push dword eax
  call [vect_draw_cont]

  add eax,16
  push dword 0xff80
  push dword arr_s
  push dword eax
  call [vect_draw_cont]

  mov ecx,3
  mov eax,cen_pt
  @@:
    push dword 0xa0a0a0
    push dword cif_tbl
    push dword eax
    call [vect_draw_cont]
    add eax,16 ;16=size
  loop @b
  ret

calc_angless:
  finit

  call get_bcd
  mov word[o_dan],bx
  fild word[o_dan]
  fmul dword[const_pi_6]
  fstp dword [c_pt_arr.h]

  call get_bcd
  mov word[o_dan],bx
  fild word[o_dan]
  fmul dword[const_pi_30]
  fstp dword [c_pt_arr.m]

  call get_bcd
  mov word[o_dan],bx
  fild word[o_dan]
  fmul dword[const_pi_30]
  fstp dword [c_pt_arr.s]

  ret

;input:
; eax - bcd
;output:
; bx - al(10)
; eax - int(bcd/100)
get_bcd:
  mov bh,al
  shr bx,12
  and ax,0xff0f
  imul bx,10
  add bl,al
  shr eax,8
  ret

key:
  mcall 2

  cmp ah,27 ;Esc
  je button.exit

  jmp still

button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  

it_is_time_now:
   mcall   26, 9
   mov	 [last_time], eax

;...  ,   Delay   ...
  mcall 3

  mov ebx,c_pt_arr
  cmp byte[erase_h],al
  je @f
    mov byte[erase_h],al
    push dword 0
    push dword arr_h
    push dword ebx
    call [vect_draw_cont]
  @@:
  add ebx,16
  cmp byte[erase_m],ah ;     
  je @f
    mov byte[erase_m],ah ;   
    push dword 0
    push dword arr_m
    push dword ebx
    call [vect_draw_cont] ;erase minute line
  @@:
  add ebx,16
  push dword 0
  push dword arr_s
  push dword ebx
  call [vect_draw_cont] ;erase second line

  call calc_angless
  call draw_objects ;draw_window
  jmp  still

txtInfo db 'Exit - [Esc]',0
hed db 'Test vectors library',0

;--------------------------------------------------
align 4
vectors_lib_import:
  vect_line dd av_line
  vect_conv_cont dd av_conv_cont
  vect_draw_cont dd av_draw_cont
  vect_opred2i dd av_opred2i
  vect_o_len dd av_o_len
  vect_o_ang dd av_o_ang
  dd 0,0
  av_line db 'vect_line',0
  av_conv_cont db 'vect_conv_cont',0
  av_draw_cont db 'vect_draw_cont',0
  av_opred2i db 'vect_opred2i',0
  av_o_len db 'vect_o_len',0
  av_o_ang db 'vect_o_ang',0

;--------------------------------------------------
system_path db '/sys/lib/'
vectors_name db 'vectors.obj',0
err_message_found_lib db 'Sorry I cannot load library vectors.obj',0
head_f_i:
head_f_l db 'System error',0
err_message_import db 'Error on load import library vectors.obj',0
;--------------------------------------------------

i_end: ; 
  rb 1024
stacktop:
  cur_dir_path:
    rb 4096
  library_path:
    rb 4096
mem:

