use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd file_name
  dd cur_dir_path

include 'macros.inc'
include 'vectors.inc' ;vectors functions constant
include 'load_lib.mac'

@use_library

struct f70
  func_n dd ?
  param1 dd ?
  param2 dd ?
  param3 dd ?
  param4 dd ?
  rezerv db ?
  name dd ?
ends

MAX_FONT_SIZE equ 15000 ;   

;-----------------------------------------------------------------------------
;input:
; ecx = size data
;otput:
; eax = pointer to memory
mem_Alloc:
  push ebx
  mcall 68,12
  pop ebx
  ret
;-----------------------------------------------------------------------------
;input:
; ecx = pointer to memory
mem_Free:
  push ebx
  cmp ecx,0
  jz @f
    mcall 68,13
  @@:
  pop ebx
  ret


delt_angl dd 0.15708 ;    

arr1c:
  dd 0xff
  .x dd 80.0
  .y dd 50.0
  .a dd 0.0 ;  (angle)
  .s dw 9 ;   


align 4
start:
  mcall 48,3
  mcall 40,0x27

  sys_load_library vectors_name, cur_dir_path, library_path, system_path, \
    err_message_found_lib, head_f_l, vectors_lib_import, err_message_import, head_f_i

  mov ecx,MAX_FONT_SIZE
  call mem_Alloc
  mov [font_data],eax

  copy_path fn_font,cur_dir_path,file_name

  mov eax,70 ;load icon file
  mov [run_file_70.func_n], 0
  mov [run_file_70.param1], 0
  mov [run_file_70.param2], 0
  mov [run_file_70.param3], MAX_FONT_SIZE
  m2m [run_file_70.param4], [font_data]
  mov [run_file_70.rezerv], 0
  mov [run_file_70.name], file_name
  mov ebx,run_file_70
  int 0x40

  cmp ebx,-1
  jne @f ;if open file
    jmp button.exit
  @@:


red_win:
  call draw_window

still:
  mcall 10

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x2
  jz key
  cmp al,0x3
  jz button
  jmp still

draw_window:
  pushad
  mcall 12,1

  xor eax,eax
  mov ebx,10*65536+620
  mov ecx,10*65536+520
  mov edx,0xffffff
  or  edx,0x33000000
  mov edi,hed
  mcall

  mov ebx,5*65536+5
  mov ecx,0x808000
  or  ecx,0x80000000
  mov edx,txtInfo
  mcall 4

  push dword txt
  push dword arr1c
  push dword [font_data]
  call [vect_draw_text]

  mcall 12,2
  popad
  ret

Text_RotLeft:
  mov bl,1
  fld dword[arr1c.a]
  fsub dword[delt_angl]
  fstp dword[arr1c.a]
  ret

Text_RotRight:
  mov bl,1
  fld dword[arr1c.a]
  fadd dword[delt_angl]
  fstp dword[arr1c.a]
  ret

Text_inc:
  cmp word[arr1c.s],150 ;max size
  jge @f
    add word[arr1c.s],5
    mov bl,1
  @@:
  ret

Text_dec:
  cmp word[arr1c.s],9 ;min size
  jle @f
    sub word[arr1c.s],5
    mov bl,1
  @@:
  ret

key:
  mcall 2

  cmp ah,27 ;Esc
  je button.exit

  xor bl,bl
  cmp ah,176 ;Left
  jne @f
    call Text_RotLeft
  @@:
  cmp ah,179 ;Right
  jne @f
    call Text_RotRight
  @@:
  cmp ah,178 ;Up
  jne @f
    call Text_inc
  @@:
  cmp ah,177 ;Down
  jne @f
    call Text_dec
  @@:
  cmp bl,1
  jne @f
    call draw_window
  @@:

  jmp still

button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mov ecx,[font_data]
  call mem_Free
  mcall -1 ;  


o_dan dd ?
hed db ' ',0
txtInfo db ': [',27,'], [',26,'] - ; [',24,'], [',25,'] - ࠧ',0

txt db 32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,13
  db '0123456789:;<=>?',13
  db '@ABCDEFGHIJKLMNO',13
  db 96,'abcdefghijklmno',13
  db 'pqrstuvwxyz{|}~',127,13
  db '',13
  db '',13
  db '',0

;--------------------------------------------------
align 4
vectors_lib_import:
  vect_line dd av_line
  vect_c_bezier dd av_c_bezier
  vect_conv_cont dd av_conv_cont
  vect_draw_cont dd av_draw_cont
  vect_opred2i dd av_opred2i
  vect_line_len4i dd av_line_len4i
  vect_draw_text dd av_draw_text
  vect_o_len dd av_o_len
  vect_o_ang dd av_o_ang

  dd 0,0
  av_line db 'vect_line',0
  av_c_bezier db 'vect_c_bezier',0
  av_conv_cont db 'vect_conv_cont',0
  av_draw_cont db 'vect_draw_cont',0
  av_opred2i db 'vect_opred2i',0
  av_line_len4i db 'vect_line_len4i',0
  av_draw_text db 'vect_draw_text',0
  av_o_len db 'vect_o_len',0
  av_o_ang db 'vect_o_ang',0

;--------------------------------------------------
system_path db '/sys/lib/'
vectors_name db 'vectors.obj',0
err_message_found_lib db 'Sorry I cannot load library vectors.obj',0
head_f_i:
head_f_l db 'System error',0
err_message_import db 'Error on load import library vectors.obj',0
;--------------------------------------------------
run_file_70 f70
font_data dd 0
fn_font db 'fnt_1.vfo',0

i_end: ; 
  rb 1024
stacktop:
  cur_dir_path:
    rb 4096
  library_path:
    rb 4096
  file_name:
    rb 4096
mem:

