use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0
  dd cur_dir_path

include 'macros.inc'
include 'vectors.inc' ;vectors functions constant
include 'load_lib.mac'

@use_library

sam:
  .x dd 30.0
  .y dd 100.0
  .a dd 0.0 ;angle
  .s dd 1.0 ;scale

cont: ;  
  dw 21
  dd -12.0,-2.0, -10.0,-2.0, -9.5,-4.0, -8.5,-4.0, -7.0,-2.0, -6.0,-2.0, -5.0,-7.0, -3.0,-7.0, 1.0,-2.0, 3.0,-2.0
  dd 5.0,0.0, 3.0,2.0, 1.0,2.0, -3.0,7.0, -5.0,7.0, -6.0,2.0, -7.0,2.0, -8.5,4.0, -9.5,4.0, -10.0,2.0, -12.0,2.0
  dw 2
  dd 5.0,0.0, 8.0,0.0
  dw 2
  dd -10.0,-2.0, -10.0,2.0
  dw 2+VECT_PARAM_COLOR
  dd 0x0080d0
  dd 0.0,0.0, 2.0,0.0
  dw 0
cont_e: ;  
  dw 21
  dd -12.0,-2.0, -10.0,-2.0, -9.5,-4.0, -8.5,-4.0, -7.0,-2.0, -6.0,-2.0, -5.0,-7.0, -3.0,-7.0, 1.0,-2.0, 3.0,-2.0
  dd 5.0,0.0, 3.0,2.0, 1.0,2.0, -3.0,7.0, -5.0,7.0, -6.0,2.0, -7.0,2.0, -8.5,4.0, -9.5,4.0, -10.0,2.0, -12.0,2.0
  dw 2
  dd 5.0,0.0, 8.0,0.0
  dw 2
  dd -10.0,-2.0, -10.0,2.0
  dw 2
  dd 0.0,0.0, 2.0,0.0
  dw 0

trees:
  dd 70.0,200.0,0.0,1.0
  dd 90.0,215.0,0.0,1.25
  dd 150.0,190.0,0.0,1.25

tree0:
  dw 2
  dd 0.0,0.0, 0.0,-3.0
  dw 12+VECT_PARAM_COLOR
  dd 0xd000
  dd 3.0,-3.0, 2.0,-5.0, 3.0,-5.0, 2.0,-7.0, 3.0,-7.0, 0.0,-11.0
  dd -3.0,-7.0, -2.0,-7.0, -3.0,-5.0, -2.0,-5.0, -3.0,-3.0, 3.0,-3.0
  dw 0

sam_prop:
  .da dd 0.15708
  .spd dd 3.0
bord:
  .left dw 10
  .top dw 25
  .right dw 300
  .bottom dw 210


last_time dd ?
key_code db 0

align 4
start:
  mcall 40,0x27

  sys_load_library vectors_name, cur_dir_path, library_path, system_path, \
    err_message_found_lib, head_f_l, vectors_lib_import, err_message_import, head_f_i

   mcall   26, 9
   mov	 [last_time], ebx

red_win:
  call draw_window

still:
   mcall   26, 9
   mov	 ebx, [last_time]
   add	 ebx, 10 ;delay
   sub	 ebx, eax
   cmp	 ebx, 10; delay
   ja	it_is_time_now
   test   ebx, ebx
   jz	it_is_time_now
   push   23
   pop	 eax
   mcall

;  mcall 10
  cmp eax,0
  je it_is_time_now

  cmp al,0x1 ;.  
  jz red_win
  cmp al,0x2
  jz key
  cmp al,0x3
  jz button
  jmp still

draw_window:
  push eax ebx ecx edx edi
  mcall 12,1

  xor eax,eax
  mov ebx,50*65536+320
  mov ecx,30*65536+250
  mov edx,0
  or  edx,0x33000000
  mov edi,hed
  mcall

  mov eax,4 ; 
  mov ebx,5*65536+5
  mov ecx,0xffff00
  or  ecx,0x80000000
  mov edx,txtInfo
  mcall

  call draw_objects

  mcall 12,2
  pop edi edx ecx ebx eax
  ret

draw_objects:
  push dword 0xff
  push dword cont
  push dword sam
  call [vect_draw_cont]

  mov ecx,3
  mov eax,trees
  @@:
    push dword 0xff8000
    push dword tree0
    push dword eax
    call [vect_draw_cont]
    add eax,16 ;16=size
  loop @b
  ret

Sam_RotLeft:
  fld dword[sam.a]
  fsub dword[sam_prop.da]
  fstp dword[sam.a]
  ret

Sam_RotRight:
  fld dword[sam.a]
  fadd dword[sam_prop.da]
  fstp dword[sam.a]
  ret

Sam_Move:
  push ax

  finit
  fld dword[sam.a]
  fcos
  fmul dword[sam_prop.spd]
  fadd dword[sam.x]
  ficom word[bord.left]
  fstsw ax
  sahf
  jae @f
    fild word[bord.left]
  @@:
  ficom word[bord.right]
  fstsw ax
  sahf
  jb @f
    fild word[bord.right]
  @@:
  fstp dword[sam.x]

  fld dword[sam.a]
  fsin
  fmul dword[sam_prop.spd]
  fadd dword[sam.y]
  ficom word[bord.top]
  fstsw ax
  sahf
  jae @f
    fild word[bord.top]
  @@:
  ficom word[bord.bottom]
  fstsw ax
  sahf
  jb @f
    fild word[bord.bottom]
  @@:
  fstp dword[sam.y]

  pop ax
  ret

key:
  mcall 2

  cmp ah,27 ;Esc
  je button.exit

  cmp ah,176 ;Left
  jne @f
    mov byte[key_code],ah
  @@:
  cmp ah,179 ;Right
  jne @f
    mov byte[key_code],ah
  @@:

  jmp still

button:
;  mcall 17 ;   
;  cmp ah,1
;  jne still
.exit:
  mcall -1 ;  

it_is_time_now:
   mcall   26, 9
   mov	 [last_time], eax

;...  ,   Delay   ...
  push dword 0
  push dword cont_e
  push dword sam
  call [vect_draw_cont] ;clear samolot

  cmp byte[key_code],176 ;Left
  jne @f
    call Sam_RotLeft
    mov byte[key_code],0
  @@:
  cmp byte[key_code],179 ;Right
  jne @f
    call Sam_RotRight
    mov byte[key_code],0
  @@:

  call Sam_Move
  call draw_objects ;draw_window
  jmp  still

txtInfo db 'Press keys [',27,'], [',26,']. Exit - [Esc]',0
hed db 'Test vectors library',0

;--------------------------------------------------
align 4
vectors_lib_import:
  vect_line dd av_line
  vect_conv_cont dd av_conv_cont
  vect_draw_cont dd av_draw_cont
  vect_opred2i dd av_opred2i
  vect_o_len dd av_o_len
  vect_o_ang dd av_o_ang
  dd 0,0
  av_line db 'vect_line',0
  av_conv_cont db 'vect_conv_cont',0
  av_draw_cont db 'vect_draw_cont',0
  av_opred2i db 'vect_opred2i',0
  av_o_len db 'vect_o_len',0
  av_o_ang db 'vect_o_ang',0

;--------------------------------------------------
system_path db '/sys/lib/'
vectors_name db 'vectors.obj',0
err_message_found_lib db 'Sorry I cannot load library vectors.obj',0
head_f_i:
head_f_l db 'System error',0
err_message_import db 'Error on load import library vectors.obj',0
;--------------------------------------------------

i_end: ; 
  rb 1024
stacktop:
  cur_dir_path:
    rb 4096
  library_path:
    rb 4096
mem:

